# Copyright (c) 2009 gocept gmbh & co. kg
# See also LICENSE.txt

import gocept.directory.interfaces
from zope.app.zopeappgenerations import getRootFolder
import zope.app.component.hooks
import random
import string


def evolve(context):
    """Ensure directory passwords for all nodes."""
    root = getRootFolder(context)
    d = root['directory']
    site_manager = d.getSiteManager()
    for name, node in site_manager.getUtilitiesFor(
            gocept.directory.interfaces.INode):
        if not hasattr(node, 'directory_password'):
            node.directory_password = (
                ''.join(random.choice(string.letters + string.digits) for x in
                        range(20)))
    zope.app.component.hooks.setSite(None)
