# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt
# $Id$

import unittest
import zope.interface.verify
import zope.component
import zope.annotation.attribute
import gocept.reference.verify

import gocept.directory.interfaces
import gocept.directory.resourcegroup

class TestInterfaces(unittest.TestCase):

    def setUp(self):
        zope.component.provideAdapter(
            zope.annotation.attribute.AttributeAnnotations)

    def test_resourcegroup(self):
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.IResourceGroup,
            gocept.directory.resourcegroup.ResourceGroup())

    def test_hostname_validator(self):
        check_hostname = gocept.directory.interfaces.check_hostname
        self.failIf(check_hostname(''))
        self.assert_(check_hostname('Host-1'))
        self.failIf(check_hostname('-host-'))
        self.failIf(check_hostname('123'))
        self.assert_(check_hostname('123-'))



def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestInterfaces))
    return suite
